XmlParser (Groovy 3.0.7)

Package groovy.util

## Class XmlParser

- java.lang.Object
- - groovy.util.XmlParser

- All Implemented Interfaces:
    `ContentHandler`

      @Deprecated
      public class XmlParser
      extends Object
      implements ContentHandler

  Deprecated.
  use `XmlParser`
  A helper class for parsing XML into a tree of Node instances for a simple way of processing XML. This parser does not preserve the XML InfoSet - if that's what you need try using W3C DOM, dom4j, JDOM, XOM etc. This parser ignores comments and processing instructions and converts the XML into a Node for each element in the XML with attributes and child Nodes and Strings. This simple model is sufficient for most simple use cases of processing XML.

  Example usage:

       def xml = '<root><one a1="uno!"/><two>Some text!</two></root>'
       def rootNode = new XmlParser().parseText(xml)
       assert rootNode.name() == 'root'
       assert rootNode.one[0].@a1 == 'uno!'
       assert rootNode.two.text() == 'Some text!'
       rootNode.children().each { assert it.name() in ['one','two'] }

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `XmlParser()` | Deprecated. Creates a non-validating and namespace-aware `XmlParser` which does not allow DOCTYPE declarations in documents.
    `XmlParser​(boolean validating, boolean namespaceAware)` | Deprecated. Creates a `XmlParser` which does not allow DOCTYPE declarations in documents.
    `XmlParser​(boolean validating, boolean namespaceAware, boolean allowDocTypeDeclaration)` | Deprecated. Creates a `XmlParser`.
    `XmlParser​(SAXParser parser)` | Deprecated.
    `XmlParser​(XMLReader reader)` | Deprecated.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `addTextToNode()` | Deprecated.
    `void` | `characters​(char[] buffer, int start, int length)` | Deprecated.
    `protected Node` | `createNode​(Node parent, Object name, Map attributes)` | Deprecated. Creates a new node with the given parent, name, and attributes.
    `void` | `endDocument()` | Deprecated.
    `void` | `endElement​(String namespaceURI, String localName, String qName)` | Deprecated.
    `void` | `endPrefixMapping​(String prefix)` | Deprecated.
    `Locator` | `getDocumentLocator()` | Deprecated.
    `DTDHandler` | `getDTDHandler()` | Deprecated.
    `protected Object` | `getElementName​(String namespaceURI, String localName, String qName)` | Deprecated. Return a name given the namespaceURI, localName and qName.
    `EntityResolver` | `getEntityResolver()` | Deprecated.
    `ErrorHandler` | `getErrorHandler()` | Deprecated.
    `boolean` | `getFeature​(String uri)` | Deprecated.
    `Object` | `getProperty​(String uri)` | Deprecated.
    `protected XMLReader` | `getXMLReader()` | Deprecated.
    `void` | `ignorableWhitespace​(char[] buffer, int start, int len)` | Deprecated.
    `boolean` | `isKeepIgnorableWhitespace()` | Deprecated. Returns the current keep ignorable whitespace setting.
    `boolean` | `isNamespaceAware()` | Deprecated. Determine if namespace handling is enabled.
    `boolean` | `isTrimWhitespace()` | Deprecated. Returns the current trim whitespace setting.
    `Node` | `parse​(File file)` | Deprecated. Parses the content of the given file as XML turning it into a tree of Nodes.
    `Node` | `parse​(InputStream input)` | Deprecated. Parse the content of the specified input stream into a tree of Nodes.
    `Node` | `parse​(Reader in)` | Deprecated. Parse the content of the specified reader into a tree of Nodes.
    `Node` | `parse​(String uri)` | Deprecated. Parse the content of the specified URI into a tree of Nodes.
    `Node` | `parse​(InputSource input)` | Deprecated. Parse the content of the specified input source into a tree of Nodes.
    `Node` | `parseText​(String text)` | Deprecated. A helper method to parse the given text as XML.
    `void` | `processingInstruction​(String target, String data)` | Deprecated.
    `void` | `setDocumentLocator​(Locator locator)` | Deprecated.
    `void` | `setDTDHandler​(DTDHandler dtdHandler)` | Deprecated.
    `void` | `setEntityResolver​(EntityResolver entityResolver)` | Deprecated.
    `void` | `setErrorHandler​(ErrorHandler errorHandler)` | Deprecated.
    `void` | `setFeature​(String uri, boolean value)` | Deprecated.
    `void` | `setKeepIgnorableWhitespace​(boolean keepIgnorableWhitespace)` | Deprecated. Sets the keep ignorable whitespace setting value.
    `void` | `setNamespaceAware​(boolean namespaceAware)` | Deprecated. Enable and/or disable namespace handling.
    `void` | `setProperty​(String uri, Object value)` | Deprecated.
    `void` | `setTrimWhitespace​(boolean trimWhitespace)` | Deprecated. Sets the trim whitespace setting value.
    `void` | `skippedEntity​(String name)` | Deprecated.
    `void` | `startDocument()` | Deprecated.
    `void` | `startElement​(String namespaceURI, String localName, String qName, Attributes list)` | Deprecated.
    `void` | `startPrefixMapping​(String prefix, String namespaceURI)` | Deprecated.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### XmlParser

          public XmlParser()
                    throws ParserConfigurationException,
                           SAXException

      Deprecated.
      Creates a non-validating and namespace-aware `XmlParser` which does not allow DOCTYPE declarations in documents.
      Throws:
        `ParserConfigurationException` - if no parser which satisfies the requested configuration can be created.
        `SAXException` - for SAX errors.

    - #### XmlParser

          public XmlParser​(boolean validating,
                           boolean namespaceAware)
                    throws ParserConfigurationException,
                           SAXException

      Deprecated.
      Creates a `XmlParser` which does not allow DOCTYPE declarations in documents.
      Parameters:
        `validating` - `true` if the parser should validate documents as they are parsed; false otherwise.
        `namespaceAware` - `true` if the parser should provide support for XML namespaces; `false` otherwise.
      Throws:
        `ParserConfigurationException` - if no parser which satisfies the requested configuration can be created.
        `SAXException` - for SAX errors.

    - #### XmlParser

          public XmlParser​(boolean validating,
                           boolean namespaceAware,
                           boolean allowDocTypeDeclaration)
                    throws ParserConfigurationException,
                           SAXException

      Deprecated.
      Creates a `XmlParser`.
      Parameters:
        `validating` - `true` if the parser should validate documents as they are parsed; false otherwise.
        `namespaceAware` - `true` if the parser should provide support for XML namespaces; `false` otherwise.
        `allowDocTypeDeclaration` - `true` if the parser should provide support for DOCTYPE declarations; `false` otherwise.
      Throws:
        `ParserConfigurationException` - if no parser which satisfies the requested configuration can be created.
        `SAXException` - for SAX errors.

    - #### XmlParser

          public XmlParser​(XMLReader reader)

      Deprecated.

    - #### XmlParser

          public XmlParser​(SAXParser parser)
                    throws SAXException

      Deprecated.
      Throws:
        `SAXException`

  - ### Method Detail

    - #### isTrimWhitespace

          public boolean isTrimWhitespace()

      Deprecated.
      Returns the current trim whitespace setting.
      Returns:
        true if whitespace will be trimmed

    - #### setTrimWhitespace

          public void setTrimWhitespace​(boolean trimWhitespace)

      Deprecated.
      Sets the trim whitespace setting value.
      Parameters:
        `trimWhitespace` - the desired setting value

    - #### isKeepIgnorableWhitespace

          public boolean isKeepIgnorableWhitespace()

      Deprecated.
      Returns the current keep ignorable whitespace setting.
      Returns:
        true if ignorable whitespace will be kept (default false)

    - #### setKeepIgnorableWhitespace

          public void setKeepIgnorableWhitespace​(boolean keepIgnorableWhitespace)

      Deprecated.
      Sets the keep ignorable whitespace setting value.
      Parameters:
        `keepIgnorableWhitespace` - the desired new value

    - #### parse

          public Node parse​(File file)
                     throws IOException,
                            SAXException

      Deprecated.
      Parses the content of the given file as XML turning it into a tree of Nodes.
      Parameters:
        `file` - the File containing the XML to be parsed
      Returns:
        the root node of the parsed tree of Nodes
      Throws:
        `SAXException` - Any SAX exception, possibly wrapping another exception.
        `IOException` - An IO exception from the parser, possibly from a byte stream or character stream supplied by the application.

    - #### parse

          public Node parse​(InputSource input)
                     throws IOException,
                            SAXException

      Deprecated.
      Parse the content of the specified input source into a tree of Nodes.
      Parameters:
        `input` - the InputSource for the XML to parse
      Returns:
        the root node of the parsed tree of Nodes
      Throws:
        `SAXException` - Any SAX exception, possibly wrapping another exception.
        `IOException` - An IO exception from the parser, possibly from a byte stream or character stream supplied by the application.

    - #### parse

          public Node parse​(InputStream input)
                     throws IOException,
                            SAXException

      Deprecated.
      Parse the content of the specified input stream into a tree of Nodes.

      Note that using this method will not provide the parser with any URI for which to find DTDs etc

      Parameters:
        `input` - an InputStream containing the XML to be parsed
      Returns:
        the root node of the parsed tree of Nodes
      Throws:
        `SAXException` - Any SAX exception, possibly wrapping another exception.
        `IOException` - An IO exception from the parser, possibly from a byte stream or character stream supplied by the application.

    - #### parse

          public Node parse​(Reader in)
                     throws IOException,
                            SAXException

      Deprecated.
      Parse the content of the specified reader into a tree of Nodes.

      Note that using this method will not provide the parser with any URI for which to find DTDs etc

      Parameters:
        `in` - a Reader to read the XML to be parsed
      Returns:
        the root node of the parsed tree of Nodes
      Throws:
        `SAXException` - Any SAX exception, possibly wrapping another exception.
        `IOException` - An IO exception from the parser, possibly from a byte stream or character stream supplied by the application.

    - #### parse

          public Node parse​(String uri)
                     throws IOException,
                            SAXException

      Deprecated.
      Parse the content of the specified URI into a tree of Nodes.
      Parameters:
        `uri` - a String containing a uri pointing to the XML to be parsed
      Returns:
        the root node of the parsed tree of Nodes
      Throws:
        `SAXException` - Any SAX exception, possibly wrapping another exception.
        `IOException` - An IO exception from the parser, possibly from a byte stream or character stream supplied by the application.

    - #### parseText

          public Node parseText​(String text)
                         throws IOException,
                                SAXException

      Deprecated.
      A helper method to parse the given text as XML.
      Parameters:
        `text` - the XML text to parse
      Returns:
        the root node of the parsed tree of Nodes
      Throws:
        `SAXException` - Any SAX exception, possibly wrapping another exception.
        `IOException` - An IO exception from the parser, possibly from a byte stream or character stream supplied by the application.

    - #### isNamespaceAware

          public boolean isNamespaceAware()

      Deprecated.
      Determine if namespace handling is enabled.
      Returns:
        true if namespace handling is enabled

    - #### setNamespaceAware

          public void setNamespaceAware​(boolean namespaceAware)

      Deprecated.
      Enable and/or disable namespace handling.
      Parameters:
        `namespaceAware` - the new desired value

    - #### getDTDHandler

          public DTDHandler getDTDHandler()

      Deprecated.

    - #### getEntityResolver

          public EntityResolver getEntityResolver()

      Deprecated.

    - #### getErrorHandler

          public ErrorHandler getErrorHandler()

      Deprecated.

    - #### getFeature

          public boolean getFeature​(String uri)
                             throws SAXNotRecognizedException,
                                    SAXNotSupportedException

      Deprecated.
      Throws:
        `SAXNotRecognizedException`
        `SAXNotSupportedException`

    - #### getProperty

          public Object getProperty​(String uri)
                             throws SAXNotRecognizedException,
                                    SAXNotSupportedException

      Deprecated.
      Throws:
        `SAXNotRecognizedException`
        `SAXNotSupportedException`

    - #### setDTDHandler

          public void setDTDHandler​(DTDHandler dtdHandler)

      Deprecated.

    - #### setEntityResolver

          public void setEntityResolver​(EntityResolver entityResolver)

      Deprecated.

    - #### setErrorHandler

          public void setErrorHandler​(ErrorHandler errorHandler)

      Deprecated.

    - #### setFeature

          public void setFeature​(String uri,
                                 boolean value)
                          throws SAXNotRecognizedException,
                                 SAXNotSupportedException

      Deprecated.
      Throws:
        `SAXNotRecognizedException`
        `SAXNotSupportedException`

    - #### setProperty

          public void setProperty​(String uri,
                                  Object value)
                           throws SAXNotRecognizedException,
                                  SAXNotSupportedException

      Deprecated.
      Throws:
        `SAXNotRecognizedException`
        `SAXNotSupportedException`

    - #### startDocument

          public void startDocument()
                             throws SAXException

      Deprecated.
      Specified by:
        `startDocument` in interface `ContentHandler`
      Throws:
        `SAXException`

    - #### endDocument

          public void endDocument()
                           throws SAXException

      Deprecated.
      Specified by:
        `endDocument` in interface `ContentHandler`
      Throws:
        `SAXException`

    - #### startElement

          public void startElement​(String namespaceURI,
                                   String localName,
                                   String qName,
                                   Attributes list)
                            throws SAXException

      Deprecated.
      Specified by:
        `startElement` in interface `ContentHandler`
      Throws:
        `SAXException`

    - #### endElement

          public void endElement​(String namespaceURI,
                                 String localName,
                                 String qName)
                          throws SAXException

      Deprecated.
      Specified by:
        `endElement` in interface `ContentHandler`
      Throws:
        `SAXException`

    - #### characters

          public void characters​(char[] buffer,
                                 int start,
                                 int length)
                          throws SAXException

      Deprecated.
      Specified by:
        `characters` in interface `ContentHandler`
      Throws:
        `SAXException`

    - #### startPrefixMapping

          public void startPrefixMapping​(String prefix,
                                         String namespaceURI)
                                  throws SAXException

      Deprecated.
      Specified by:
        `startPrefixMapping` in interface `ContentHandler`
      Throws:
        `SAXException`

    - #### endPrefixMapping

          public void endPrefixMapping​(String prefix)
                                throws SAXException

      Deprecated.
      Specified by:
        `endPrefixMapping` in interface `ContentHandler`
      Throws:
        `SAXException`

    - #### ignorableWhitespace

          public void ignorableWhitespace​(char[] buffer,
                                          int start,
                                          int len)
                                   throws SAXException

      Deprecated.
      Specified by:
        `ignorableWhitespace` in interface `ContentHandler`
      Throws:
        `SAXException`

    - #### processingInstruction

          public void processingInstruction​(String target,
                                            String data)
                                     throws SAXException

      Deprecated.
      Specified by:
        `processingInstruction` in interface `ContentHandler`
      Throws:
        `SAXException`

    - #### getDocumentLocator

          public Locator getDocumentLocator()

      Deprecated.

    - #### setDocumentLocator

          public void setDocumentLocator​(Locator locator)

      Deprecated.
      Specified by:
        `setDocumentLocator` in interface `ContentHandler`

    - #### skippedEntity

          public void skippedEntity​(String name)
                             throws SAXException

      Deprecated.
      Specified by:
        `skippedEntity` in interface `ContentHandler`
      Throws:
        `SAXException`

    - #### getXMLReader

          protected XMLReader getXMLReader()

      Deprecated.

    - #### addTextToNode

          protected void addTextToNode()

      Deprecated.

    - #### createNode

          protected Node createNode​(Node parent,
                                    Object name,
                                    Map attributes)

      Deprecated.
      Creates a new node with the given parent, name, and attributes. The default implementation returns an instance of `groovy.util.Node`.
      Parameters:
        `parent` - the parent node, or null if the node being created is the root node
        `name` - an Object representing the name of the node (typically an instance of `QName`)
        `attributes` - a Map of attribute names to attribute values
      Returns:
        a new Node instance representing the current node

    - #### getElementName

          protected Object getElementName​(String namespaceURI,
                                          String localName,
                                          String qName)

      Deprecated.
      Return a name given the namespaceURI, localName and qName.
      Parameters:
        `namespaceURI` - the namespace URI
        `localName` - the local name
        `qName` - the qualified name
      Returns:
        the newly created representation of the name